#ifndef	Z80INTRF_H
#define Z80INTRF_H

#include "DrZ80.h"

#define Z80_IGNORE_INT	-1 /* Ignore interrupt */
#define Z80_NMI_INT 	-2 /* Execute NMI */
#define Z80_IRQ_INT 	-1000 /* Execute IRQ */

#define z80_int(VEC) Z80_Interrupt(VEC);
#define z80_exec(CIC) Z80_Execute(CIC)
#define z80_nmi() Z80_Interrupt(Z80_NMI_INT);

extern unsigned char subcpu_memspace[0x10000];
extern unsigned int sound_code;
extern unsigned int pending_command;
extern unsigned int result_code;
extern int Z80_VBL_CYCLES;
extern int z80_cycles;

extern int Z80_Execute(int cycles); /* Execute cycles T-States - returns number of cycles actually run */
extern void Z80_Interrupt(int type);

extern void z80_init (void);

#endif /* Z80INTRF_H */

