#ifndef __ncpu_h__
#define __ncpu_h__

#include <SDL.h>

#define IRQ_REQ cpu_pending_irq();
#define NMI_REQ cpu_nmi();

extern Sint32 g_wPassedClocks;

#ifdef __cplusplus
extern "C" {
#endif

extern void cpu_pending_irq(void);
extern void cpu_irq(void);
extern void cpu_nmi(void);
extern int cpu_getcycles(void);
extern int cpu_exec(Uint32 total_cycles);
extern void cpu_burn(Uint32 burn_cycles);
extern void cpu_release(void);
extern void init_sram(Uint8 *sram);
extern void reset_cpu(void);
extern void init_cpu(Uint8 *nesram);
extern void set_cpu_bank_full(Uint8 *bank0,Uint8 *bank1,Uint8 *bank2,Uint8 *bank3);
extern void set_cpu_bank0(Uint8 *bank0);
extern void set_cpu_bank1(Uint8 *bank1);
extern void set_cpu_bank2(Uint8 *bank2);
extern void set_cpu_bank3(Uint8 *bank3);
extern void reload_fast_pc(void);

extern void get_context(Uint32* nesregs);
extern void set_context(Uint32* nesregs);

extern Uint8 Rd6502(Uint32 wAddr);
extern void Wr6502(Uint32 wAddr, Uint8 byData);

#ifdef __cplusplus
}
#endif

#endif
