#ifndef NES_H
#define NES_H

#define SECTION_FAST //.section emu.fast, "awx"
#define SECTION_SLOW //.section emu.slow, "awx"
#define SECTION_HEAD //.section emu.head, "awx"

#define ALIGN .align 4

/*
 * 6502 ̃WX^
 *
 * A ͏ 24 rbgVtgĂ
 * P 2ɕB
 * NZ͂قƂǂ̖߂ύX̂ŁCNŽɂȂlۑ
 * c͑̏ꏊɒu
 *
 * S 24rbgVtgĂ
 * ŗ]ĉ̃rbg P ̎cu(VBDI)
 * ɗ]ĂƂɂ͊荞݂ɊւtOu
 *
 * PC ROM̃AhXɕϊĂ
 * ̏ꍇ͋E`FbNق̂CȒPł͂Ȃ
 * { PC 𓾂邽߂ɂ݂͌̃oN̐擪AhX΂悢
 */
#define REG_A  r4
#define REG_X  r5
#define REG_Y  r6
#define REG_PC r7
#define REG_S  r8
#define REG_NZ  r9
#define REG_P_REST REG_S

#if 0
/*
 * REG_P ŎgtO
 */
#define ARM_N_FLAG 0x80000000
#define ARM_Z_FLAG 0x40000000
#define ARM_C_FLAG 0x20000000
#define ARM_V_FLAG 0x10000000
#endif

/*
 * REG_P_REST ɂ͊etOu
 *
 * 0
 * FEDCBA98 76543210
 * |||||||| |||||||+---C L[܂̓{[Ȃ
 * |||||||| ||||||+---NMI̔
 * |||||||| |||||+---I 荞݋
 * |||||||| ||||+---D \i[h
 * |||||||| |||+---B
 * |||||||| ||+---IRQ̔
 * |||||||| |+---V I[o[t[
 * |||||||| +---$2005/$2006 gOtO
 * ||||||||
 * |||||||+---$2000[2] 32CNg
 * ||||||+---$2000[3] XvCgAhXI
 * |||||+---$2000[4] obNOEhAhXI
 * ||||+---$2000[5] XvCgTCY
 * |||+---gp
 * ||+---$2000[7] NMI
 * |+---$2001[3] obNOEh`
 * +---$2001[4] XvCg`
 *
 * 1
 * FEDCBA9876543210
 * |||||||||||||||+---$2002[4] VRAMɏ݉H
 * ||||||||||||||+---$2002[5] XvCg
 * |||||||||||||+---$2002[6] XvCgqbg(ł̂H)
 * ||||||||||||+---$2002[7] VBL
 * |||||||||||+---DMC荞ݔ
 * ||||||||||+---VRAMĂ
 * ||||||||++---gp
 * ++++++++---S X^bN|C^
 *
 */


/*
 * REG_P_REST ŎgtOB{IPƓʒuɂ
 */
#define P_REST_V_FLAG 0x40
#define P_REST_B_FLAG 0x10
#define P_REST_D_FLAG 0x08
#define P_REST_I_FLAG 0x04
#define P_REST_C_FLAG 0x01
#define P_REST_FLAGS  0x5D

/*
 * 荞݂ƃZbg
 */
#define P_REST_INT_PENDING 0x20
#define P_REST_NMI_PENDING 0x02

#define ASSERT_NMI	orr	REG_P_REST, REG_P_REST, #P_REST_NMI_PENDING
#define ASSERT_INT	orr	REG_P_REST, REG_P_REST, #P_REST_INT_PENDING


/*
 * 6502 ̖{̃tO
 */
#define P_N_FLAG 0x80
#define P_V_FLAG 0x40
#define P_R_FLAG 0x20
#define P_B_FLAG 0x10
#define P_D_FLAG 0x08
#define P_I_FLAG 0x04
#define P_Z_FLAG 0x02
#define P_C_FLAG 0x01

#define NMI_VECTOR   6
#define RESET_VECTOR 4
#define IRQ_VECTOR   2

/*
 * ꂽAhX
 */
#define REG_ADDR r10

/*
 * cTCN
 */
#define REG_CYCLE r11

/*
 * ߂̃Wve[u
 */
#define REG_OP_TABLE r12

#endif
