#include "snes9x.h"
#include "apu.h"
#include "ppu.h"
#include "dsp1.h"
#include "cpuexec.h"
#include "sa1.h"
#include "cpuops.h"

#include "os9x_asm_cpu.h"

//#define __debug_c_irq__
//#define __debug_c_nmi__
//#define __debug_c_hblank__
//#define __debug_c_io__
//#define __debug_c_apuex__

START_EXTERN_C

void asm_S9xMainLoop(void)
{
	S9xPackStatus();
//	printf("asmMainLoop Enter(0x%08x).\n", CPU.Flags);
	asmMainLoop(&CPU);
//	printf("asmMainLoop Exit(0x%08x, %d).\n", CPU.PC - CPU.PCBase, CPU.Cycles);
	S9xUnpackStatus();
}

uint8 asm_S9xGetByte(uint32 Address)
{
#ifdef __debug_c_io__
	printf("gb\n");
#endif
	return S9xGetByte(Address);
}

uint16 asm_S9xGetWord(uint32 Address)
{
#ifdef __debug_c_io__
	printf("gw\n");
#endif
	return S9xGetWord(Address);
}


void asm_S9xSetByte(uint32 Address,uint8 value)
{
#ifdef __debug_c_io__
	printf("sb\n");
#endif
	S9xSetByte(value,Address);
}

void asm_S9xSetWord(uint32 Address,uint16 value)
{
#ifdef __debug_c_io__
	printf("sw\n");
#endif
	S9xSetWord(value,Address);
}



void asm_S9xSetPCBase(uint32 Address)
{
#ifdef __debug_c_setpc__
	printf("spcb\n");
#endif
	S9xSetPCBase(Address);
}


void asm_S9xOpcode_NMI(void)
{
#ifdef __debug_c_nmi__
	printf("nmi\n");
#endif
	S9xUnpackStatus();
	S9xOpcode_NMI();
	S9xPackStatus();
}

void asm_S9xOpcode_IRQ(void)
{
#ifdef __debug_c_irq__
	printf("irq\n");
#endif
	S9xUnpackStatus();
	S9xOpcode_IRQ();
	S9xPackStatus();
}

void asm_S9xDoHBlankProcessing(void)
{
#ifdef __debug_c_hblank__
	printf("hblank\n");
#endif
	S9xUnpackStatus();
	S9xDoHBlankProcessing();
	S9xPackStatus();
}

void asm_APU_EXECUTE(void)
{
#ifdef __debug_c_apuex__
	printf("apuexec\n");
#endif
	while (APU.Cycles <= CPU.Cycles)
	{
		APU_EXECUTE1();
	}
}

void asm_APU_EXECUTE2(void)
{
#ifdef __debug_c_apuex__
	printf("apuexec2\n");
#endif
	ICPU.CPUExecuting = FALSE;
	do
	{
	    APU_EXECUTE1();
	} while (APU.Cycles < CPU.NextEvent);
	ICPU.CPUExecuting = TRUE;
}

END_EXTERN_C
